<?xml version="1.0" encoding="UTF-8"?>
<?eclipse version="3.0"?>

<plugin>

    <extension
            point="org.eclipse.ui.editors">
        <editor
              class="org.eclipse.osbp.dsl.entity.xtext.ui.EntityGrammarExecutableExtensionFactory:org.eclipse.xtext.ui.editor.XtextEditor"
              contributorClass="org.eclipse.ui.editors.text.TextEditorActionContributor"
              default="true"
              extensions="entity"
              icon="icons/dsl_entity.png"
              id="org.eclipse.osbp.dsl.entity.xtext.EntityGrammar"
              name="OSBP Entity Editor">
        </editor>
    </extension>
    <extension
        point="org.eclipse.ui.handlers">
        <handler
            class="org.eclipse.osbp.dsl.entity.xtext.ui.EntityGrammarExecutableExtensionFactory:org.eclipse.xtext.ui.editor.hyperlinking.OpenDeclarationHandler"
            commandId="org.eclipse.xtext.ui.editor.hyperlinking.OpenDeclaration">
            <activeWhen>
                <reference
                    definitionId="org.eclipse.osbp.dsl.entity.xtext.EntityGrammar.Editor.opened">
                </reference>
            </activeWhen>
        </handler>
        <handler
            class="org.eclipse.osbp.dsl.entity.xtext.ui.EntityGrammarExecutableExtensionFactory:org.eclipse.xtext.ui.editor.handler.ValidateActionHandler"
            commandId="org.eclipse.osbp.dsl.entity.xtext.EntityGrammar.validate">
         <activeWhen>
            <reference
                    definitionId="org.eclipse.osbp.dsl.entity.xtext.EntityGrammar.Editor.opened">
            </reference>
         </activeWhen>
      </handler>
    </extension>
    <extension point="org.eclipse.core.expressions.definitions">
        <definition id="org.eclipse.osbp.dsl.entity.xtext.EntityGrammar.Editor.opened">
            <and>
                <reference definitionId="isActiveEditorAnInstanceOfXtextEditor"/>
                <with variable="activeEditor">
                    <test property="org.eclipse.xtext.ui.editor.XtextEditor.languageName" 
                        value="org.eclipse.osbp.dsl.entity.xtext.EntityGrammar" 
                        forcePluginActivation="true"/>
                </with>        
            </and>
        </definition>
    </extension>
    <extension
            point="org.eclipse.ui.preferencePages">
        <page
              category="org.eclipse.osbp.eclipse.ui.preferences.RootPreferencePage"
              class="org.eclipse.osbp.dsl.entity.xtext.ui.EntityGrammarExecutableExtensionFactory:org.eclipse.xtext.ui.editor.preferences.LanguageRootPreferencePage"
              id="org.eclipse.osbp.dsl.entity.xtext.EntityGrammar"
			  icon="icons/dsl_entity.png"
              name="OSBP EntityDsl">
            <keywordReference id="org.eclipse.osbp.dsl.entity.xtext.ui.keyword_Entity"/>
        </page>
        <page
            category="org.eclipse.osbp.dsl.entity.xtext.EntityGrammar"
            class="org.eclipse.osbp.dsl.entity.xtext.ui.EntityGrammarExecutableExtensionFactory:org.eclipse.xtext.ui.editor.syntaxcoloring.SyntaxColoringPreferencePage"
            id="org.eclipse.osbp.dsl.entity.xtext.EntityGrammar.coloring"
  		    icon="icons/dsl_entity.png"
            name="Syntax Coloring">
            <keywordReference id="org.eclipse.osbp.dsl.entity.xtext.ui.keyword_Entity"/>
        </page>
        <page
            category="org.eclipse.osbp.dsl.entity.xtext.EntityGrammar"
            class="org.eclipse.osbp.dsl.entity.xtext.ui.EntityGrammarExecutableExtensionFactory:org.eclipse.xtext.ui.editor.templates.XtextTemplatePreferencePage"
            id="org.eclipse.osbp.dsl.entity.xtext.EntityGrammar.templates"
  		    icon="icons/dsl_entity.png"
            name="Templates">
            <keywordReference id="org.eclipse.osbp.dsl.entity.xtext.ui.keyword_Entity"/>
        </page>
    </extension>
    <extension
            point="org.eclipse.ui.propertyPages">
        <page
              category="org.eclipse.osbp.eclipse.ui.rootPropertyPage"
              class="org.eclipse.osbp.dsl.entity.xtext.ui.EntityGrammarExecutableExtensionFactory:org.eclipse.xtext.ui.editor.preferences.LanguageRootPreferencePage"
              icon="icons/dsl_entity.png"
              id="org.eclipse.osbp.dsl.entity.xtext.EntityGrammar"
              name="OSBP EntityDsl">
            <keywordReference id="org.eclipse.osbp.dsl.entity.xtext.ui.keyword_Entity"/>
            <enabledWhen>
	            <adapt type="org.eclipse.core.resources.IProject"/>
			</enabledWhen>
	        <filter name="projectNature" value="org.eclipse.xtext.ui.shared.xtextNature"/>
        </page>
    </extension>
    <extension
        point="org.eclipse.ui.keywords">
        <keyword
            id="org.eclipse.osbp.dsl.entity.xtext.ui.keyword_Entity"
            label="Entity"/>
    </extension>
    <extension
         point="org.eclipse.ui.commands">
      <command
            description="Trigger expensive validation"
            id="org.eclipse.osbp.dsl.entity.xtext.EntityGrammar.validate"
            name="Validate">
      </command>
    </extension>
    <extension point="org.eclipse.ui.menus">
        <menuContribution
            locationURI="popup:#TextEditorContext?after=group.edit">
             <command
                 commandId="org.eclipse.osbp.dsl.entity.xtext.EntityGrammar.validate"
                 style="push"
                 tooltip="Trigger expensive validation">
            <visibleWhen checkEnabled="false">
                <reference
                    definitionId="org.eclipse.osbp.dsl.entity.xtext.EntityGrammar.Editor.opened">
                </reference>
            </visibleWhen>
         </command>  
         </menuContribution>
    </extension>
    <extension point="org.eclipse.ui.menus">
		<menuContribution locationURI="popup:#TextEditorContext?endof=group.find">
			<command commandId="org.eclipse.xtext.ui.editor.FindReferences">
				<visibleWhen checkEnabled="false">
                	<reference definitionId="org.eclipse.osbp.dsl.entity.xtext.EntityGrammar.Editor.opened">
                	</reference>
            	</visibleWhen>
			</command>
		</menuContribution>
	</extension>
	<extension point="org.eclipse.ui.handlers">
	    <handler
            class="org.eclipse.osbp.dsl.entity.xtext.ui.EntityGrammarExecutableExtensionFactory:org.eclipse.xtext.ui.editor.findrefs.FindReferencesHandler"
            commandId="org.eclipse.xtext.ui.editor.FindReferences">
            <activeWhen>
                <reference
                    definitionId="org.eclipse.osbp.dsl.entity.xtext.EntityGrammar.Editor.opened">
                </reference>
            </activeWhen>
        </handler>
    </extension>   

<!-- adding resource factories -->

	<extension
		point="org.eclipse.emf.ecore.extension_parser">
		<parser
			class="org.eclipse.osbp.dsl.entity.xtext.ui.EntityGrammarExecutableExtensionFactory:org.eclipse.xtext.resource.IResourceFactory"
			type="entity">
		</parser>
	</extension>
	<extension point="org.eclipse.xtext.extension_resourceServiceProvider">
        <resourceServiceProvider
            class="org.eclipse.osbp.dsl.entity.xtext.ui.EntityGrammarExecutableExtensionFactory:org.eclipse.xtext.ui.resource.IResourceUIServiceProvider"
            uriExtension="entity">
        </resourceServiceProvider>
    </extension>



   <extension
         point="org.eclipse.xtext.builder.participant">
      <participant
            class="org.eclipse.osbp.dsl.entity.xtext.ui.EntityGrammarExecutableExtensionFactory:org.eclipse.xtext.builder.IXtextBuilderParticipant">
      </participant>
   </extension>
   <extension
            point="org.eclipse.ui.preferencePages">
        <page
            category="org.eclipse.osbp.dsl.entity.xtext.EntityGrammar"
            class="org.eclipse.osbp.dsl.entity.xtext.ui.EntityGrammarExecutableExtensionFactory:org.eclipse.xtext.builder.preferences.BuilderPreferencePage"
            id="org.eclipse.osbp.dsl.entity.xtext.EntityGrammar.compiler.preferencePage"
            icon="icons/dsl_entity.png"
            name="Compiler">
            <keywordReference id="org.eclipse.osbp.dsl.entity.xtext.ui.keyword_Entity"/>
        </page>
    </extension>
    <extension
            point="org.eclipse.ui.propertyPages">
        <page
            category="org.eclipse.osbp.dsl.entity.xtext.EntityGrammar"
            class="org.eclipse.osbp.dsl.entity.xtext.ui.EntityGrammarExecutableExtensionFactory:org.eclipse.xtext.builder.preferences.BuilderPreferencePage"
            id="org.eclipse.osbp.dsl.entity.xtext.EntityGrammar.compiler.propertyPage"
            icon="icons/dsl_entity.png"
            name="Compiler">
            <keywordReference id="org.eclipse.osbp.dsl.entity.xtext.ui.keyword_Entity"/>
            <enabledWhen>
	            <adapt type="org.eclipse.core.resources.IProject"/>
			</enabledWhen>
	        <filter name="projectNature" value="org.eclipse.xtext.ui.shared.xtextNature"/>
        </page>
    </extension>

	<!-- Quick Outline -->
	<extension
		point="org.eclipse.ui.handlers">
		<handler 
			class="org.eclipse.osbp.dsl.entity.xtext.ui.EntityGrammarExecutableExtensionFactory:org.eclipse.xtext.ui.editor.outline.quickoutline.ShowQuickOutlineActionHandler"
			commandId="org.eclipse.xtext.ui.editor.outline.QuickOutline">
			<activeWhen>
				<reference
					definitionId="org.eclipse.osbp.dsl.entity.xtext.EntityGrammar.Editor.opened">
				</reference>
			</activeWhen>
		</handler>
	</extension>
	<extension
		point="org.eclipse.ui.commands">
		<command
			description="Open the quick outline."
			id="org.eclipse.xtext.ui.editor.outline.QuickOutline"
			name="Quick Outline">
		</command>
	</extension>
	<extension point="org.eclipse.ui.menus">
		<menuContribution
			locationURI="popup:#TextEditorContext?after=group.open">
			<command commandId="org.eclipse.xtext.ui.editor.outline.QuickOutline"
				style="push"
				tooltip="Open Quick Outline">
				<visibleWhen checkEnabled="false">
					<reference definitionId="org.eclipse.osbp.dsl.entity.xtext.EntityGrammar.Editor.opened"/>
				</visibleWhen>
			</command>
		</menuContribution>
	</extension>
   <!-- quickfix marker resolution generator -->
   <extension
         point="org.eclipse.ui.ide.markerResolution">
      <markerResolutionGenerator
            class="org.eclipse.osbp.dsl.entity.xtext.ui.EntityGrammarExecutableExtensionFactory:org.eclipse.xtext.ui.editor.quickfix.MarkerResolutionGenerator">
      </markerResolutionGenerator>
   </extension>
   	<!-- Rename Refactoring -->
	<extension point="org.eclipse.ui.handlers">
		<handler 
			class="org.eclipse.osbp.dsl.entity.xtext.ui.EntityGrammarExecutableExtensionFactory:org.eclipse.xtext.ui.refactoring.ui.IRenameElementHandler"
			commandId="org.eclipse.xtext.ui.refactoring.RenameElement">
			<activeWhen>
				<reference
					definitionId="org.eclipse.osbp.dsl.entity.xtext.EntityGrammar.Editor.opened">
				</reference>
			</activeWhen>
		</handler>
	</extension>
    <extension point="org.eclipse.ui.menus">
         <menuContribution
            locationURI="popup:#TextEditorContext?after=group.edit">
         <command commandId="org.eclipse.xtext.ui.refactoring.RenameElement"
               style="push">
            <visibleWhen checkEnabled="false">
               <reference
                     definitionId="org.eclipse.osbp.dsl.entity.xtext.EntityGrammar.Editor.opened">
               </reference>
            </visibleWhen>
         </command>
      </menuContribution>
   </extension>
   <extension point="org.eclipse.ui.preferencePages">
	    <page
	        category="org.eclipse.osbp.dsl.entity.xtext.EntityGrammar"
	        class="org.eclipse.osbp.dsl.entity.xtext.ui.EntityGrammarExecutableExtensionFactory:org.eclipse.xtext.ui.refactoring.ui.RefactoringPreferencePage"
	        id="org.eclipse.osbp.dsl.entity.xtext.EntityGrammar.refactoring"
            icon="icons/dsl_entity.png"
 	        name="Refactoring">
	        <keywordReference id="org.eclipse.osbp.dsl.entity.xtext.ui.keyword_Entity"/>
	    </page>
	</extension>

<!-- Type Hierarchy  -->
	<extension
		point="org.eclipse.ui.handlers">
		<handler 
			class="org.eclipse.osbp.dsl.entity.xtext.ui.EntityGrammarExecutableExtensionFactory:org.eclipse.xtext.xbase.ui.hierarchy.OpenTypeHierarchyHandler"
			commandId="org.eclipse.xtext.xbase.ui.hierarchy.OpenTypeHierarchy">
			<activeWhen>
				<reference
					definitionId="org.eclipse.osbp.dsl.entity.xtext.EntityGrammar.Editor.opened">
				</reference>
			</activeWhen>
		</handler>
		<handler 
			class="org.eclipse.osbp.dsl.entity.xtext.ui.EntityGrammarExecutableExtensionFactory:org.eclipse.xtext.xbase.ui.hierarchy.QuickTypeHierarchyHandler"
			commandId="org.eclipse.jdt.ui.edit.text.java.open.hierarchy">
			<activeWhen>
				<reference
					definitionId="org.eclipse.osbp.dsl.entity.xtext.EntityGrammar.Editor.opened">
				</reference>
			</activeWhen>
		</handler>
	</extension>
	<extension point="org.eclipse.ui.menus">
		<menuContribution
			locationURI="popup:#TextEditorContext?after=group.open">
			<command commandId="org.eclipse.xtext.xbase.ui.hierarchy.OpenTypeHierarchy"
				style="push"
				tooltip="Open Type Hierarchy">
				<visibleWhen checkEnabled="false">
					<reference definitionId="org.eclipse.osbp.dsl.entity.xtext.EntityGrammar.Editor.opened"/>
				</visibleWhen>
			</command>
		</menuContribution>
		<menuContribution
			locationURI="popup:#TextEditorContext?after=group.open">
			<command commandId="org.eclipse.jdt.ui.edit.text.java.open.hierarchy"
				style="push"
				tooltip="Quick Type Hierarchy">
				<visibleWhen checkEnabled="false">
					<reference definitionId="org.eclipse.osbp.dsl.entity.xtext.EntityGrammar.Editor.opened"/>
				</visibleWhen>
			</command>
		</menuContribution>
	</extension>
	<!-- Organize imports  -->
	<extension
		point="org.eclipse.ui.handlers">
		<handler
            class="org.eclipse.osbp.dsl.entity.xtext.ui.EntityGrammarExecutableExtensionFactory:org.eclipse.osbp.xtext.oxtype.ui.imports.OXTypeOrganizeImportsHandler"
            commandId="org.eclipse.xtext.xbase.ui.organizeImports">
           	<activeWhen>
				<reference
					definitionId="org.eclipse.osbp.dsl.entity.xtext.EntityGrammar.Editor.opened">
				</reference>
			</activeWhen>
        </handler>
	</extension>
		<extension point="org.eclipse.ui.menus">
		<menuContribution
            locationURI="menu:#xtext.ui.SourceMenu?after=xtext.ui.ImportsSeparator">
             <command
                 commandId="org.eclipse.xtext.xbase.ui.organizeImports"
                 style="push"
                 tooltip="Organize Imports">
                <visibleWhen checkEnabled="false">
                    <reference
                        definitionId="org.eclipse.osbp.dsl.entity.xtext.EntityGrammar.Editor.opened">
                    </reference>
                </visibleWhen>
            </command>  
        </menuContribution>
	</extension>
  <extension point="org.eclipse.compare.contentViewers">
    <viewer id="org.eclipse.osbp.dsl.entity.xtext.EntityGrammar.compare.contentViewers"
            class="org.eclipse.osbp.dsl.entity.xtext.ui.EntityGrammarExecutableExtensionFactory:org.eclipse.xtext.ui.compare.InjectableViewerCreator"
            extensions="entity">
    </viewer>
  </extension>
  <extension point="org.eclipse.compare.contentMergeViewers">
    <viewer id="org.eclipse.osbp.dsl.entity.xtext.EntityGrammar.compare.contentMergeViewers"
            class="org.eclipse.osbp.dsl.entity.xtext.ui.EntityGrammarExecutableExtensionFactory:org.eclipse.xtext.ui.compare.InjectableViewerCreator"
            extensions="entity" label="Entity Compare">
     </viewer>
  </extension>
  <extension point="org.eclipse.ui.editors.documentProviders">
    <provider id="org.eclipse.osbp.dsl.entity.xtext.EntityGrammar.editors.documentProviders"
            class="org.eclipse.osbp.dsl.entity.xtext.ui.EntityGrammarExecutableExtensionFactory:org.eclipse.xtext.ui.editor.model.XtextDocumentProvider"
            extensions="entity">
    </provider>
  </extension>
  <extension
        point="org.eclipse.ui.newWizards">
       <wizard
             category="org.eclipse.osbp.ui.wizards.category"
             class="org.eclipse.osbp.dsl.entity.xtext.ui.EntityGrammarExecutableExtensionFactory:org.eclipse.osbp.dsl.entity.xtext.ui.wizards.OSBPNewEntityModelWizard"
             icon="icons/dsl_entity.png"
             id="org.eclipse.osbp.dsl.entity.xtext.ui.wizards.entityNewProjectWizard"
             name="OSBP Entity Model">
      </wizard>
      </extension>
      
     <extension
         point="org.eclipse.xtext.builder.participant">
      <participant
            class="org.eclipse.osbp.dsl.entity.xtext.ui.EntityGrammarExecutableExtensionFactory:org.eclipse.osbp.dsl.entity.xtext.ui.builder.PersistenceXMLBuilderParticipant">
      </participant>
   </extension>
</plugin>
